local L = AceLibrary("AceLocale-2.2"):new("GridStatusAFK")

--{{{ Localization

L:RegisterTranslations("enUS", function()
	return {
		["AFK"] = true,
		["<AFK>"] = true,
		["AFK alert"] = true,
	}
end)

---}}}

GridStatusAFK = GridStatus:NewModule("GridStatusAFK")
GridStatusAFK.menuName = L["AFK"]

--{{{ AceDB defaults

GridStatusAFK.defaultDB = {
	debug = false,
	alert_afk = {
		text =  L["<AFK>"],
		enable = false,
		color = { r = 0.5, g = 0.5, b = 0.5, a = 0.5 },
		priority = 20,
		range = false,
	},
}

--}}}

GridStatusAFK.options = false

function GridStatusAFK:OnInitialize()
	self.super.OnInitialize(self)
	self:RegisterStatus("alert_afk", L["AFK alert"], nil, true)
end

function GridStatusAFK:OnEnable()
	self:RegisterEvent("PLAYER_FLAGS_CHANGED")
	self:RegisterEvent("Grid_UnitJoined")
end

function GridStatusAFK:PLAYER_FLAGS_CHANGED(unitid)
	local settings = self.db.profile.alert_afk
	if string.find(unitid, "pet") then return end

	if UnitIsAFK(unitid) then
		self.core:SendStatusGained(UnitName(unitid), "alert_afk",
						settings.priority,
						(settings.range and 40),
						settings.color,
						settings.text,
						nil,
						nil,
						settings.icon)
	else
		self.core:SendStatusLost(UnitName(unitid), "alert_afk")
	end
end

function GridStatusAFK:Grid_UnitJoined(name,unitid)
	self:PLAYER_FLAGS_CHANGED(unitid)
end